Index: /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/NEMO/NST_SRC/agrif_opa_interp.F90
===================================================================
--- /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/NEMO/NST_SRC/agrif_opa_interp.F90	(revision 10250)
+++ /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/NEMO/NST_SRC/agrif_opa_interp.F90	(revision 10251)
@@ -7,5 +7,4 @@
    !!             -   !  2005-11  (XXX) 
    !!            3.2  !  2009-04  (R. Benshila) 
-   !!            3.6  !  2014-09  (R. Benshila) 
    !!----------------------------------------------------------------------
 #if defined key_agrif && ! defined key_offline
@@ -30,42 +29,139 @@
    USE wrk_nemo
    USE dynspg_oce
-   USE zdf_oce
- 
+
    IMPLICIT NONE
    PRIVATE
 
-   INTEGER :: bdy_tinterp = 0
-
+   ! Barotropic arrays used to store open boundary data during
+   ! time-splitting loop:
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::  ubdy_w, vbdy_w, hbdy_w
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::  ubdy_e, vbdy_e, hbdy_e
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::  ubdy_n, vbdy_n, hbdy_n
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::  ubdy_s, vbdy_s, hbdy_s
+    
    PUBLIC   Agrif_tra, Agrif_dyn, Agrif_ssh, Agrif_dyn_ts, Agrif_ssh_ts, Agrif_dta_ts
-   PUBLIC   interpun, interpvn, interpun2d, interpvn2d 
-   PUBLIC   interptsn,  interpsshn
-   PUBLIC   interpunb, interpvnb, interpub2b, interpvb2b
-   PUBLIC   interpe3t, interpumsk, interpvmsk
-# if defined key_zdftke
-   PUBLIC   Agrif_tke, interpavm
-# endif
+   PUBLIC   interpu, interpv, interpunb, interpvnb, interpsshn
 
 #  include "domzgr_substitute.h90"  
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/NST 3.6 , NEMO Consortium (2010)
+   !! NEMO/NST 3.3 , NEMO Consortium (2010)
    !! $Id$
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
-CONTAINS
-
+   CONTAINS
+   
    SUBROUTINE Agrif_tra
       !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE Agrif_tra  ***
+      !!                  ***  ROUTINE Agrif_Tra  ***
+      !!----------------------------------------------------------------------
+      !!
+      INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
+      REAL(wp) ::   zrhox , alpha1, alpha2, alpha3
+      REAL(wp) ::   alpha4, alpha5, alpha6, alpha7
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztsa
       !!----------------------------------------------------------------------
       !
       IF( Agrif_Root() )   RETURN
 
+      CALL wrk_alloc( jpi, jpj, jpk, jpts, ztsa ) 
+
       Agrif_SpecialValue    = 0.e0
       Agrif_UseSpecialValue = .TRUE.
-
-      CALL Agrif_Bc_variable( tsn_id, procname=interptsn )
+      ztsa(:,:,:,:) = 0.e0
+
+      CALL Agrif_Bc_variable( ztsa, tsn_id, procname=interptsn )
       Agrif_UseSpecialValue = .FALSE.
+
+      zrhox = Agrif_Rhox()
+
+      alpha1 = ( zrhox - 1. ) * 0.5
+      alpha2 = 1. - alpha1
+
+      alpha3 = ( zrhox - 1. ) / ( zrhox + 1. )
+      alpha4 = 1. - alpha3
+
+      alpha6 = 2. * ( zrhox - 1. ) / ( zrhox + 1. )
+      alpha7 =    - ( zrhox - 1. ) / ( zrhox + 3. )
+      alpha5 = 1. - alpha6 - alpha7
+
+      IF( nbondi == 1 .OR. nbondi == 2 ) THEN
+
+         DO jn = 1, jpts
+            tsa(nlci,:,:,jn) = alpha1 * ztsa(nlci,:,:,jn) + alpha2 * ztsa(nlci-1,:,:,jn)
+            DO jk = 1, jpkm1
+               DO jj = 1, jpj
+                  IF( umask(nlci-2,jj,jk) == 0.e0 ) THEN
+                     tsa(nlci-1,jj,jk,jn) = tsa(nlci,jj,jk,jn) * tmask(nlci-1,jj,jk)
+                  ELSE
+                     tsa(nlci-1,jj,jk,jn)=(alpha4*tsa(nlci,jj,jk,jn)+alpha3*tsa(nlci-2,jj,jk,jn))*tmask(nlci-1,jj,jk)
+                     IF( un(nlci-2,jj,jk) > 0.e0 ) THEN
+                        tsa(nlci-1,jj,jk,jn)=( alpha6*tsa(nlci-2,jj,jk,jn)+alpha5*tsa(nlci,jj,jk,jn)  &
+                           &                 + alpha7*tsa(nlci-3,jj,jk,jn) ) * tmask(nlci-1,jj,jk)
+                     ENDIF
+                  ENDIF
+               END DO
+            END DO
+         ENDDO
+      ENDIF
+
+      IF( nbondj == 1 .OR. nbondj == 2 ) THEN
+
+         DO jn = 1, jpts
+            tsa(:,nlcj,:,jn) = alpha1 * ztsa(:,nlcj,:,jn) + alpha2 * ztsa(:,nlcj-1,:,jn)
+            DO jk = 1, jpkm1
+               DO ji = 1, jpi
+                  IF( vmask(ji,nlcj-2,jk) == 0.e0 ) THEN
+                     tsa(ji,nlcj-1,jk,jn) = tsa(ji,nlcj,jk,jn) * tmask(ji,nlcj-1,jk)
+                  ELSE
+                     tsa(ji,nlcj-1,jk,jn)=(alpha4*tsa(ji,nlcj,jk,jn)+alpha3*tsa(ji,nlcj-2,jk,jn))*tmask(ji,nlcj-1,jk)        
+                     IF (vn(ji,nlcj-2,jk) > 0.e0 ) THEN
+                        tsa(ji,nlcj-1,jk,jn)=( alpha6*tsa(ji,nlcj-2,jk,jn)+alpha5*tsa(ji,nlcj,jk,jn)  &
+                           &                 + alpha7*tsa(ji,nlcj-3,jk,jn) ) * tmask(ji,nlcj-1,jk)
+                     ENDIF
+                  ENDIF
+               END DO
+            END DO
+         ENDDO 
+      ENDIF
+
+      IF( nbondi == -1 .OR. nbondi == 2 ) THEN
+         DO jn = 1, jpts
+            tsa(1,:,:,jn) = alpha1 * ztsa(1,:,:,jn) + alpha2 * ztsa(2,:,:,jn)
+            DO jk = 1, jpkm1
+               DO jj = 1, jpj
+                  IF( umask(2,jj,jk) == 0.e0 ) THEN
+                     tsa(2,jj,jk,jn) = tsa(1,jj,jk,jn) * tmask(2,jj,jk)
+                  ELSE
+                     tsa(2,jj,jk,jn)=(alpha4*tsa(1,jj,jk,jn)+alpha3*tsa(3,jj,jk,jn))*tmask(2,jj,jk)        
+                     IF( un(2,jj,jk) < 0.e0 ) THEN
+                        tsa(2,jj,jk,jn)=(alpha6*tsa(3,jj,jk,jn)+alpha5*tsa(1,jj,jk,jn)+alpha7*tsa(4,jj,jk,jn))*tmask(2,jj,jk)
+                     ENDIF
+                  ENDIF
+               END DO
+            END DO
+         END DO
+      ENDIF
+
+      IF( nbondj == -1 .OR. nbondj == 2 ) THEN
+         DO jn = 1, jpts
+            tsa(:,1,:,jn) = alpha1 * ztsa(:,1,:,jn) + alpha2 * ztsa(:,2,:,jn)
+            DO jk=1,jpk      
+               DO ji=1,jpi
+                  IF( vmask(ji,2,jk) == 0.e0 ) THEN
+                     tsa(ji,2,jk,jn)=tsa(ji,1,jk,jn) * tmask(ji,2,jk)
+                  ELSE
+                     tsa(ji,2,jk,jn)=(alpha4*tsa(ji,1,jk,jn)+alpha3*tsa(ji,3,jk,jn))*tmask(ji,2,jk)
+                     IF( vn(ji,2,jk) < 0.e0 ) THEN
+                        tsa(ji,2,jk,jn)=(alpha6*tsa(ji,3,jk,jn)+alpha5*tsa(ji,1,jk,jn)+alpha7*tsa(ji,4,jk,jn))*tmask(ji,2,jk)
+                     ENDIF
+                  ENDIF
+               END DO
+            END DO
+         ENDDO
+      ENDIF
+      !
+      CALL wrk_dealloc( jpi, jpj, jpk, jpts, ztsa ) 
       !
    END SUBROUTINE Agrif_tra
@@ -79,27 +175,16 @@
       INTEGER, INTENT(in) ::   kt
       !!
-      INTEGER :: ji,jj,jk, j1,j2, i1,i2
+      INTEGER :: ji,jj,jk
       REAL(wp) :: timeref
       REAL(wp) :: z2dt, znugdt
       REAL(wp) :: zrhox, zrhoy
-      REAL(wp), POINTER, DIMENSION(:,:) :: spgv1, spgu1
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zua, zva
+      REAL(wp), POINTER, DIMENSION(:,:) :: spgv1, spgu1, zua2d, zva2d
       !!----------------------------------------------------------------------  
 
       IF( Agrif_Root() )   RETURN
 
-      CALL wrk_alloc( jpi, jpj, spgv1, spgu1 )
-
-      Agrif_SpecialValue=0.
-      Agrif_UseSpecialValue = ln_spc_dyn
-
-      CALL Agrif_Bc_variable(un_interp_id,procname=interpun)
-      CALL Agrif_Bc_variable(vn_interp_id,procname=interpvn)
-
-#if defined key_dynspg_flt
-      CALL Agrif_Bc_variable(e1u_id,calledweight=1., procname=interpun2d)
-      CALL Agrif_Bc_variable(e2v_id,calledweight=1., procname=interpvn2d)
-#endif
-
-      Agrif_UseSpecialValue = .FALSE.
+      CALL wrk_alloc( jpi, jpj, spgv1, spgu1, zua2d, zva2d )
+      CALL wrk_alloc( jpi, jpj, jpk, zua, zva )
 
       zrhox = Agrif_Rhox()
@@ -107,4 +192,5 @@
 
       timeref = 1.
+
       ! time step: leap-frog
       z2dt = 2. * rdt
@@ -114,19 +200,41 @@
       znugdt =  grav * z2dt    
 
-      ! prevent smoothing in ghost cells
-      i1=1
-      i2=jpi
-      j1=1
-      j2=jpj
-      IF((nbondj == -1).OR.(nbondj == 2)) j1 = 3
-      IF((nbondj == +1).OR.(nbondj == 2)) j2 = nlcj-2
-      IF((nbondi == -1).OR.(nbondi == 2)) i1 = 3
-      IF((nbondi == +1).OR.(nbondi == 2)) i2 = nlci-2
+      Agrif_SpecialValue=0.
+      Agrif_UseSpecialValue = ln_spc_dyn
+
+      zua = 0.
+      zva = 0.
+      CALL Agrif_Bc_variable(zua,un_id,procname=interpu)
+      CALL Agrif_Bc_variable(zva,vn_id,procname=interpv)
+      zua2d = 0.
+      zva2d = 0.
+
+#if defined key_dynspg_flt
+      Agrif_SpecialValue=0.
+      Agrif_UseSpecialValue = ln_spc_dyn
+      CALL Agrif_Bc_variable(zua2d,e1u_id,calledweight=1.,procname=interpu2d)
+      CALL Agrif_Bc_variable(zva2d,e2v_id,calledweight=1.,procname=interpv2d)
+#endif
+      Agrif_UseSpecialValue = .FALSE.
 
 
       IF((nbondi == -1).OR.(nbondi == 2)) THEN
+
 #if defined key_dynspg_flt
-         DO jk=1,jpkm1
-            DO jj=j1,j2
+         DO jj=1,jpj
+            laplacu(2,jj) = timeref * (zua2d(2,jj)/(zrhoy*e2u(2,jj)))*umask(2,jj,1)
+         END DO
+#endif
+
+         DO jk=1,jpkm1
+            DO jj=1,jpj
+               ua(1:2,jj,jk) = (zua(1:2,jj,jk)/(zrhoy*e2u(1:2,jj)))
+               ua(1:2,jj,jk) = ua(1:2,jj,jk) / fse3u_a(1:2,jj,jk)
+            END DO
+         END DO
+
+#if defined key_dynspg_flt
+         DO jk=1,jpkm1
+            DO jj=1,jpj
                ua(2,jj,jk) = (ua(2,jj,jk) - z2dt * znugdt * laplacu(2,jj))*umask(2,jj,jk)
             END DO
@@ -137,5 +245,5 @@
          DO jk=1,jpkm1
             DO jj=1,jpj
-               spgu(2,jj)=spgu(2,jj)+fse3u(2,jj,jk)*ua(2,jj,jk)
+               spgu(2,jj)=spgu(2,jj)+fse3u_a(2,jj,jk)*ua(2,jj,jk)
             END DO
          END DO
@@ -143,5 +251,5 @@
          DO jj=1,jpj
             IF (umask(2,jj,1).NE.0.) THEN
-               spgu(2,jj)=spgu(2,jj)/hu(2,jj)
+               spgu(2,jj)=spgu(2,jj)*hur_a(2,jj)
             ENDIF
          END DO
@@ -151,5 +259,5 @@
 
          DO jk=1,jpkm1
-            DO jj=j1,j2
+            DO jj=1,jpj
                ua(2,jj,jk) = 0.25*(ua(1,jj,jk)+2.*ua(2,jj,jk)+ua(3,jj,jk))
                ua(2,jj,jk) = ua(2,jj,jk) * umask(2,jj,jk)
@@ -161,5 +269,5 @@
          DO jk=1,jpkm1
             DO jj=1,jpj
-               spgu1(2,jj)=spgu1(2,jj)+fse3u(2,jj,jk)*ua(2,jj,jk)
+               spgu1(2,jj)=spgu1(2,jj)+fse3u_a(2,jj,jk)*ua(2,jj,jk)
             END DO
          END DO
@@ -167,11 +275,18 @@
          DO jj=1,jpj
             IF (umask(2,jj,1).NE.0.) THEN
-               spgu1(2,jj)=spgu1(2,jj)/hu(2,jj)
+               spgu1(2,jj)=spgu1(2,jj)*hur_a(2,jj)
             ENDIF
          END DO
 
          DO jk=1,jpkm1
-            DO jj=j1,j2
+            DO jj=1,jpj
                ua(2,jj,jk) = (ua(2,jj,jk)+spgu(2,jj)-spgu1(2,jj))*umask(2,jj,jk)
+            END DO
+         END DO
+
+         DO jk=1,jpkm1
+            DO jj=1,jpj
+               va(2,jj,jk) = (zva(2,jj,jk)/(zrhox*e1v(2,jj)))*vmask(2,jj,jk)
+               va(2,jj,jk) = va(2,jj,jk) / fse3v_a(2,jj,jk)
             END DO
          END DO
@@ -185,7 +300,9 @@
             END DO
          END DO
+
          DO jj=1,jpj
             spgv1(2,jj)=spgv1(2,jj)*hvr_a(2,jj)
          END DO
+
          DO jk=1,jpkm1
             DO jj=1,jpj
@@ -199,18 +316,35 @@
       IF((nbondi == 1).OR.(nbondi == 2)) THEN
 #if defined key_dynspg_flt
-         DO jk=1,jpkm1
-            DO jj=j1,j2
+         DO jj=1,jpj
+            laplacu(nlci-2,jj) = timeref * (zua2d(nlci-2,jj)/(zrhoy*e2u(nlci-2,jj)))
+         END DO
+#endif
+
+         DO jk=1,jpkm1
+            DO jj=1,jpj
+               ua(nlci-2:nlci-1,jj,jk) = (zua(nlci-2:nlci-1,jj,jk)/(zrhoy*e2u(nlci-2:nlci-1,jj)))
+               ua(nlci-2:nlci-1,jj,jk) = ua(nlci-2:nlci-1,jj,jk) / fse3u_a(nlci-2:nlci-1,jj,jk)
+            END DO
+         END DO
+
+#if defined key_dynspg_flt
+         DO jk=1,jpkm1
+            DO jj=1,jpj
                ua(nlci-2,jj,jk) = (ua(nlci-2,jj,jk)- z2dt * znugdt * laplacu(nlci-2,jj))*umask(nlci-2,jj,jk)
             END DO
          END DO
+
+
          spgu(nlci-2,:)=0.
-         DO jk=1,jpkm1
-            DO jj=1,jpj
-               spgu(nlci-2,jj)=spgu(nlci-2,jj)+fse3u(nlci-2,jj,jk)*ua(nlci-2,jj,jk)
-            ENDDO
-         ENDDO
+
+         do jk=1,jpkm1
+            do jj=1,jpj
+               spgu(nlci-2,jj)=spgu(nlci-2,jj)+fse3u_a(nlci-2,jj,jk)*ua(nlci-2,jj,jk)
+            enddo
+         enddo
+
          DO jj=1,jpj
             IF (umask(nlci-2,jj,1).NE.0.) THEN
-               spgu(nlci-2,jj)=spgu(nlci-2,jj)/hu(nlci-2,jj)
+               spgu(nlci-2,jj)=spgu(nlci-2,jj)*hur_a(nlci-2,jj)
             ENDIF
          END DO
@@ -218,6 +352,7 @@
          spgu(nlci-2,:) = ua_b(nlci-2,:)
 #endif
-         DO jk=1,jpkm1
-            DO jj=j1,j2
+
+         DO jk=1,jpkm1
+            DO jj=1,jpj
                ua(nlci-2,jj,jk) = 0.25*(ua(nlci-3,jj,jk)+2.*ua(nlci-2,jj,jk)+ua(nlci-1,jj,jk))
 
@@ -226,18 +361,29 @@
             END DO
          END DO
+
          spgu1(nlci-2,:)=0.
-         DO jk=1,jpkm1
-            DO jj=1,jpj
-               spgu1(nlci-2,jj)=spgu1(nlci-2,jj)+fse3u(nlci-2,jj,jk)*ua(nlci-2,jj,jk)*umask(nlci-2,jj,jk)
-            END DO
-         END DO
+
+         DO jk=1,jpkm1
+            DO jj=1,jpj
+               spgu1(nlci-2,jj)=spgu1(nlci-2,jj)+fse3u_a(nlci-2,jj,jk)*ua(nlci-2,jj,jk)*umask(nlci-2,jj,jk)
+            END DO
+         END DO
+
          DO jj=1,jpj
             IF (umask(nlci-2,jj,1).NE.0.) THEN
-               spgu1(nlci-2,jj)=spgu1(nlci-2,jj)/hu(nlci-2,jj)
+               spgu1(nlci-2,jj)=spgu1(nlci-2,jj)*hur_a(nlci-2,jj)
             ENDIF
          END DO
-         DO jk=1,jpkm1
-            DO jj=j1,j2
+
+         DO jk=1,jpkm1
+            DO jj=1,jpj
                ua(nlci-2,jj,jk) = (ua(nlci-2,jj,jk)+spgu(nlci-2,jj)-spgu1(nlci-2,jj))*umask(nlci-2,jj,jk)
+            END DO
+         END DO
+
+         DO jk=1,jpkm1
+            DO jj=1,jpj-1
+               va(nlci-1,jj,jk) = (zva(nlci-1,jj,jk)/(zrhox*e1v(nlci-1,jj)))*vmask(nlci-1,jj,jk)
+               va(nlci-1,jj,jk) = va(nlci-1,jj,jk) / fse3v_a(nlci-1,jj,jk)
             END DO
          END DO
@@ -268,4 +414,17 @@
 
 #if defined key_dynspg_flt
+         DO ji=1,jpi
+            laplacv(ji,2) = timeref * (zva2d(ji,2)/(zrhox*e1v(ji,2)))
+         END DO
+#endif
+
+         DO jk=1,jpkm1
+            DO ji=1,jpi
+               va(ji,1:2,jk) = (zva(ji,1:2,jk)/(zrhox*e1v(ji,1:2)))
+               va(ji,1:2,jk) = va(ji,1:2,jk) / fse3v_a(ji,1:2,jk)
+            END DO
+         END DO
+
+#if defined key_dynspg_flt
          DO jk=1,jpkm1
             DO ji=1,jpi
@@ -278,5 +437,5 @@
          DO jk=1,jpkm1
             DO ji=1,jpi
-               spgv(ji,2)=spgv(ji,2)+fse3v(ji,2,jk)*va(ji,2,jk)
+               spgv(ji,2)=spgv(ji,2)+fse3v_a(ji,2,jk)*va(ji,2,jk)
             END DO
          END DO
@@ -284,5 +443,5 @@
          DO ji=1,jpi
             IF (vmask(ji,2,1).NE.0.) THEN
-               spgv(ji,2)=spgv(ji,2)/hv(ji,2)
+               spgv(ji,2)=spgv(ji,2)*hvr_a(ji,2)
             ENDIF
          END DO
@@ -292,5 +451,5 @@
 
          DO jk=1,jpkm1
-            DO ji=i1,i2
+            DO ji=1,jpi
                va(ji,2,jk)=0.25*(va(ji,1,jk)+2.*va(ji,2,jk)+va(ji,3,jk))
                va(ji,2,jk)=va(ji,2,jk)*vmask(ji,2,jk)
@@ -302,5 +461,5 @@
          DO jk=1,jpkm1
             DO ji=1,jpi
-               spgv1(ji,2)=spgv1(ji,2)+fse3v(ji,2,jk)*va(ji,2,jk)*vmask(ji,2,jk)
+               spgv1(ji,2)=spgv1(ji,2)+fse3v_a(ji,2,jk)*va(ji,2,jk)*vmask(ji,2,jk)
             END DO
          END DO
@@ -308,5 +467,5 @@
          DO ji=1,jpi
             IF (vmask(ji,2,1).NE.0.) THEN
-               spgv1(ji,2)=spgv1(ji,2)/hv(ji,2)
+               spgv1(ji,2)=spgv1(ji,2)*hvr_a(ji,2)
             ENDIF
          END DO
@@ -315,4 +474,11 @@
             DO ji=1,jpi
                va(ji,2,jk) = (va(ji,2,jk)+spgv(ji,2)-spgv1(ji,2))*vmask(ji,2,jk)
+            END DO
+         END DO
+
+         DO jk=1,jpkm1
+            DO ji=1,jpi
+               ua(ji,2,jk) = (zua(ji,2,jk)/(zrhoy*e2u(ji,2)))*umask(ji,2,jk) 
+               ua(ji,2,jk) = ua(ji,2,jk) / fse3u_a(ji,2,jk)
             END DO
          END DO
@@ -342,4 +508,17 @@
 
 #if defined key_dynspg_flt
+         DO ji=1,jpi
+            laplacv(ji,nlcj-2) = timeref * (zva2d(ji,nlcj-2)/(zrhox*e1v(ji,nlcj-2)))
+         END DO
+#endif
+
+         DO jk=1,jpkm1
+            DO ji=1,jpi
+               va(ji,nlcj-2:nlcj-1,jk) = (zva(ji,nlcj-2:nlcj-1,jk)/(zrhox*e1v(ji,nlcj-2:nlcj-1)))
+               va(ji,nlcj-2:nlcj-1,jk) = va(ji,nlcj-2:nlcj-1,jk) / fse3v_a(ji,nlcj-2:nlcj-1,jk)
+            END DO
+         END DO
+
+#if defined key_dynspg_flt
          DO jk=1,jpkm1
             DO ji=1,jpi
@@ -348,10 +527,9 @@
          END DO
 
-
          spgv(:,nlcj-2)=0.
 
          DO jk=1,jpkm1
             DO ji=1,jpi
-               spgv(ji,nlcj-2)=spgv(ji,nlcj-2)+fse3v(ji,nlcj-2,jk)*va(ji,nlcj-2,jk)
+               spgv(ji,nlcj-2)=spgv(ji,nlcj-2)+fse3v_a(ji,nlcj-2,jk)*va(ji,nlcj-2,jk)
             END DO
          END DO
@@ -359,8 +537,7 @@
          DO ji=1,jpi
             IF (vmask(ji,nlcj-2,1).NE.0.) THEN
-               spgv(ji,nlcj-2)=spgv(ji,nlcj-2)/hv(ji,nlcj-2)
+               spgv(ji,nlcj-2)=spgv(ji,nlcj-2)*hvr_a(ji,nlcj-2)
             ENDIF
          END DO
-
 #else
          spgv(:,nlcj-2)=va_b(:,nlcj-2)
@@ -368,5 +545,5 @@
 
          DO jk=1,jpkm1
-            DO ji=i1,i2
+            DO ji=1,jpi
                va(ji,nlcj-2,jk)=0.25*(va(ji,nlcj-3,jk)+2.*va(ji,nlcj-2,jk)+va(ji,nlcj-1,jk))
                va(ji,nlcj-2,jk) = va(ji,nlcj-2,jk) * vmask(ji,nlcj-2,jk)
@@ -378,5 +555,5 @@
          DO jk=1,jpkm1
             DO ji=1,jpi
-               spgv1(ji,nlcj-2)=spgv1(ji,nlcj-2)+fse3v(ji,nlcj-2,jk)*va(ji,nlcj-2,jk)
+               spgv1(ji,nlcj-2)=spgv1(ji,nlcj-2)+fse3v_a(ji,nlcj-2,jk)*va(ji,nlcj-2,jk)
             END DO
          END DO
@@ -384,5 +561,5 @@
          DO ji=1,jpi
             IF (vmask(ji,nlcj-2,1).NE.0.) THEN
-               spgv1(ji,nlcj-2)=spgv1(ji,nlcj-2)/hv(ji,nlcj-2)
+               spgv1(ji,nlcj-2)=spgv1(ji,nlcj-2)*hvr_a(ji,nlcj-2)
             ENDIF
          END DO
@@ -391,4 +568,11 @@
             DO ji=1,jpi
                va(ji,nlcj-2,jk) = (va(ji,nlcj-2,jk)+spgv(ji,nlcj-2)-spgv1(ji,nlcj-2))*vmask(ji,nlcj-2,jk)
+            END DO
+         END DO
+
+         DO jk=1,jpkm1
+            DO ji=1,jpi
+               ua(ji,nlcj-1,jk) = (zua(ji,nlcj-1,jk)/(zrhoy*e2u(ji,nlcj-1)))*umask(ji,nlcj-1,jk)
+               ua(ji,nlcj-1,jk) = ua(ji,nlcj-1,jk) / fse3u_a(ji,nlcj-1,jk)
             END DO
          END DO
@@ -416,5 +600,6 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, spgv1, spgu1 )
+      CALL wrk_dealloc( jpi, jpj, spgv1, spgu1, zua2d, zva2d )
+      CALL wrk_dealloc( jpi, jpj, jpk, zua, zva )
       !
    END SUBROUTINE Agrif_dyn
@@ -435,9 +620,9 @@
          DO jj=1,jpj
             va_e(2,jj) = vbdy_w(jj) * hvr_e(2,jj)
-            ! Specified fluxes:
+! Specified fluxes:
             ua_e(2,jj) = ubdy_w(jj) * hur_e(2,jj)
-            ! Characteristics method:
-            !alt            ua_e(2,jj) = 0.5_wp * ( ubdy_w(jj) * hur_e(2,jj) + ua_e(3,jj) &
-            !alt                       &           - sqrt(grav * hur_e(2,jj)) * (sshn_e(3,jj) - hbdy_w(jj)) )
+! Characteristics method:
+!alt            ua_e(2,jj) = 0.5_wp * ( ubdy_w(jj) * hur_e(2,jj) + ua_e(3,jj) &
+!alt                       &           - sqrt(grav * hur_e(2,jj)) * (sshn_e(3,jj) - hbdy_w(jj)) )
          END DO
       ENDIF
@@ -446,9 +631,9 @@
          DO jj=1,jpj
             va_e(nlci-1,jj) = vbdy_e(jj) * hvr_e(nlci-1,jj)
-            ! Specified fluxes:
+! Specified fluxes:
             ua_e(nlci-2,jj) = ubdy_e(jj) * hur_e(nlci-2,jj)
-            ! Characteristics method:
-            !alt            ua_e(nlci-2,jj) = 0.5_wp * ( ubdy_e(jj) * hur_e(nlci-2,jj) + ua_e(nlci-3,jj) &
-            !alt                            &           + sqrt(grav * hur_e(nlci-2,jj)) * (sshn_e(nlci-2,jj) - hbdy_e(jj)) )
+! Characteristics method:
+!alt            ua_e(nlci-2,jj) = 0.5_wp * ( ubdy_e(jj) * hur_e(nlci-2,jj) + ua_e(nlci-3,jj) &
+!alt                            &           + sqrt(grav * hur_e(nlci-2,jj)) * (sshn_e(nlci-2,jj) - hbdy_e(jj)) )
          END DO
       ENDIF
@@ -457,9 +642,9 @@
          DO ji=1,jpi
             ua_e(ji,2) = ubdy_s(ji) * hur_e(ji,2)
-            ! Specified fluxes:
+! Specified fluxes:
             va_e(ji,2) = vbdy_s(ji) * hvr_e(ji,2)
-            ! Characteristics method:
-            !alt            va_e(ji,2) = 0.5_wp * ( vbdy_s(ji) * hvr_e(ji,2) + va_e(ji,3) &
-            !alt                       &           - sqrt(grav * hvr_e(ji,2)) * (sshn_e(ji,3) - hbdy_s(ji)) )
+! Characteristics method:
+!alt            va_e(ji,2) = 0.5_wp * ( vbdy_s(ji) * hvr_e(ji,2) + va_e(ji,3) &
+!alt                       &           - sqrt(grav * hvr_e(ji,2)) * (sshn_e(ji,3) - hbdy_s(ji)) )
          END DO
       ENDIF
@@ -468,9 +653,9 @@
          DO ji=1,jpi
             ua_e(ji,nlcj-1) = ubdy_n(ji) * hur_e(ji,nlcj-1)
-            ! Specified fluxes:
+! Specified fluxes:
             va_e(ji,nlcj-2) = vbdy_n(ji) * hvr_e(ji,nlcj-2)
-            ! Characteristics method:
-            !alt            va_e(ji,nlcj-2) = 0.5_wp * ( vbdy_n(ji) * hvr_e(ji,nlcj-2)  + va_e(ji,nlcj-3) &
-            !alt                            &           + sqrt(grav * hvr_e(ji,nlcj-2)) * (sshn_e(ji,nlcj-2) - hbdy_n(ji)) )
+! Characteristics method:
+!alt            va_e(ji,nlcj-2) = 0.5_wp * ( vbdy_n(ji) * hvr_e(ji,nlcj-2)  + va_e(ji,nlcj-3) &
+!alt                            &           + sqrt(grav * hvr_e(ji,nlcj-2)) * (sshn_e(ji,nlcj-2) - hbdy_n(ji)) )
          END DO
       ENDIF
@@ -487,5 +672,9 @@
       INTEGER :: ji, jj
       LOGICAL :: ll_int_cons
-      REAL(wp) :: zrhot, zt
+      REAL(wp) :: zrhox, zrhoy, zrhot, zt
+      REAL(wp) :: zaa, zab, zat
+      REAL(wp) :: zt0, zt1
+      REAL(wp), POINTER, DIMENSION(:,:) :: zunb, zvnb, zsshn
+      REAL(wp), POINTER, DIMENSION(:,:) :: zuab, zvab, zubb, zvbb, zutn, zvtn
       !!----------------------------------------------------------------------  
 
@@ -493,7 +682,18 @@
 
       ll_int_cons = ln_bt_fw ! Assume conservative temporal integration in
-      ! the forward case only
-
+                             ! the forward case only
+
+      zrhox = Agrif_Rhox()
+      zrhoy = Agrif_Rhoy()
       zrhot = Agrif_rhot()
+
+      IF ( kt==nit000 ) THEN ! Allocate boundary data arrays
+         ALLOCATE( ubdy_w(jpj), vbdy_w(jpj), hbdy_w(jpj))
+         ALLOCATE( ubdy_e(jpj), vbdy_e(jpj), hbdy_e(jpj))
+         ALLOCATE( ubdy_n(jpi), vbdy_n(jpi), hbdy_n(jpi))
+         ALLOCATE( ubdy_s(jpi), vbdy_s(jpi), hbdy_s(jpi))
+      ENDIF
+
+      CALL wrk_alloc( jpi, jpj, zunb, zvnb, zsshn )
 
       ! "Central" time index for interpolation:
@@ -507,5 +707,5 @@
       Agrif_SpecialValue    = 0.e0
       Agrif_UseSpecialValue = .TRUE.
-      CALL Agrif_Bc_variable(sshn_id,calledweight=zt, procname=interpsshn )
+      CALL Agrif_Bc_variable(zsshn, sshn_id,calledweight=zt, procname=interpsshn )
       Agrif_UseSpecialValue = .FALSE.
 
@@ -515,24 +715,96 @@
 
       IF (ll_int_cons) THEN ! Conservative interpolation
-         ! orders matters here !!!!!!
-         CALL Agrif_Bc_variable(ub2b_interp_id,calledweight=1._wp, procname=interpub2b) ! Time integrated
-         CALL Agrif_Bc_variable(vb2b_interp_id,calledweight=1._wp, procname=interpvb2b)
-         bdy_tinterp = 1
-         CALL Agrif_Bc_variable(unb_id ,calledweight=1._wp, procname=interpunb) ! After
-         CALL Agrif_Bc_variable(vnb_id ,calledweight=1._wp, procname=interpvnb)
-         bdy_tinterp = 2
-         CALL Agrif_Bc_variable(unb_id ,calledweight=0._wp, procname=interpunb) ! Before
-         CALL Agrif_Bc_variable(vnb_id ,calledweight=0._wp, procname=interpvnb)         
+         CALL wrk_alloc( jpi, jpj, zuab, zvab, zubb, zvbb, zutn, zvtn )
+         zuab(:,:) = 0._wp ; zvab(:,:) = 0._wp
+         zubb(:,:) = 0._wp ; zvbb(:,:) = 0._wp
+         zutn(:,:) = 0._wp ; zvtn(:,:) = 0._wp
+         CALL Agrif_Bc_variable(zubb,unb_id ,calledweight=0._wp, procname=interpunb) ! Before
+         CALL Agrif_Bc_variable(zvbb,vnb_id ,calledweight=0._wp, procname=interpvnb)
+         CALL Agrif_Bc_variable(zuab,unb_id ,calledweight=1._wp, procname=interpunb) ! After
+         CALL Agrif_Bc_variable(zvab,vnb_id ,calledweight=1._wp, procname=interpvnb)
+         CALL Agrif_Bc_variable(zutn,ub2b_id,calledweight=1._wp, procname=interpub2b)! Time integrated
+         CALL Agrif_Bc_variable(zvtn,vb2b_id,calledweight=1._wp, procname=interpvb2b)
+         
+         ! Time indexes bounds for integration
+         zt0 = REAL(Agrif_NbStepint()  , wp) / zrhot
+         zt1 = REAL(Agrif_NbStepint()+1, wp) / zrhot
+
+         ! Polynomial interpolation coefficients:
+         zaa = zrhot * (  zt1**2._wp * (       zt1 - 1._wp)        &
+                 &      - zt0**2._wp * (       zt0 - 1._wp)        )
+         zab = zrhot * (  zt1        * (       zt1 - 1._wp)**2._wp &
+                 &      - zt0        * (       zt0 - 1._wp)**2._wp )
+         zat = zrhot * (  zt1**2._wp * (-2._wp*zt1 + 3._wp)        &
+                 &      - zt0**2._wp * (-2._wp*zt0 + 3._wp)        ) 
+
+         ! Do time interpolation
+         IF((nbondi == -1).OR.(nbondi == 2)) THEN
+            DO jj=1,jpj
+               zunb(2,jj) = zaa * zuab(2,jj) + zab * zubb(2,jj) + zat * zutn(2,jj)
+               zvnb(2,jj) = zaa * zvab(2,jj) + zab * zvbb(2,jj) + zat * zvtn(2,jj)
+            END DO
+         ENDIF
+         IF((nbondi == 1).OR.(nbondi == 2)) THEN
+            DO jj=1,jpj
+               zunb(nlci-2,jj) = zaa * zuab(nlci-2,jj) + zab * zubb(nlci-2,jj) + zat * zutn(nlci-2,jj)
+               zvnb(nlci-1,jj) = zaa * zvab(nlci-1,jj) + zab * zvbb(nlci-1,jj) + zat * zvtn(nlci-1,jj)
+            END DO
+         ENDIF
+         IF((nbondj == -1).OR.(nbondj == 2)) THEN
+            DO ji=1,jpi
+               zunb(ji,2) = zaa * zuab(ji,2) + zab * zubb(ji,2) + zat * zutn(ji,2)
+               zvnb(ji,2) = zaa * zvab(ji,2) + zab * zvbb(ji,2) + zat * zvtn(ji,2)
+            END DO
+         ENDIF
+         IF((nbondj == 1).OR.(nbondj == 2)) THEN
+            DO ji=1,jpi
+               zunb(ji,nlcj-1) = zaa * zuab(ji,nlcj-1) + zab * zubb(ji,nlcj-1) + zat * zutn(ji,nlcj-1)
+               zvnb(ji,nlcj-2) = zaa * zvab(ji,nlcj-2) + zab * zvbb(ji,nlcj-2) + zat * zvtn(ji,nlcj-2)
+            END DO
+         ENDIF
+         CALL wrk_dealloc( jpi, jpj, zuab, zvab, zubb, zvbb, zutn, zvtn )
+
       ELSE ! Linear interpolation
-         bdy_tinterp = 0
-         ubdy_w(:) = 0.e0 ; vbdy_w(:) = 0.e0 
-         ubdy_e(:) = 0.e0 ; vbdy_e(:) = 0.e0 
-         ubdy_n(:) = 0.e0 ; vbdy_n(:) = 0.e0 
-         ubdy_s(:) = 0.e0 ; vbdy_s(:) = 0.e0 
-         CALL Agrif_Bc_variable(unb_id,calledweight=zt, procname=interpunb)
-         CALL Agrif_Bc_variable(vnb_id,calledweight=zt, procname=interpvnb)
+         zunb(:,:) = 0._wp ; zvnb(:,:) = 0._wp
+         CALL Agrif_Bc_variable(zunb,unb_id,calledweight=zt, procname=interpunb)
+         CALL Agrif_Bc_variable(zvnb,vnb_id,calledweight=zt, procname=interpvnb)
       ENDIF
       Agrif_UseSpecialValue = .FALSE.
-      ! 
+
+      ! Fill boundary data arrays:
+      IF((nbondi == -1).OR.(nbondi == 2)) THEN
+         DO jj=1,jpj
+               ubdy_w(jj) = (zunb(2,jj)/(zrhoy*e2u(2,jj))) * umask(2,jj,1)
+               vbdy_w(jj) = (zvnb(2,jj)/(zrhox*e1v(2,jj))) * vmask(2,jj,1)
+               hbdy_w(jj) = zsshn(2,jj) * tmask(2,jj,1)
+         END DO
+      ENDIF
+
+      IF((nbondi == 1).OR.(nbondi == 2)) THEN
+         DO jj=1,jpj
+               ubdy_e(jj) = zunb(nlci-2,jj)/(zrhoy*e2u(nlci-2,jj)) * umask(nlci-2,jj,1)
+               vbdy_e(jj) = zvnb(nlci-1,jj)/(zrhox*e1v(nlci-1,jj)) * vmask(nlci-1,jj,1)
+               hbdy_e(jj) = zsshn(nlci-1,jj) * tmask(nlci-1,jj,1)
+         END DO
+      ENDIF
+
+      IF((nbondj == -1).OR.(nbondj == 2)) THEN
+         DO ji=1,jpi
+               ubdy_s(ji) = zunb(ji,2)/(zrhoy*e2u(ji,2)) * umask(ji,2,1)
+               vbdy_s(ji) = zvnb(ji,2)/(zrhox*e1v(ji,2)) * vmask(ji,2,1)
+               hbdy_s(ji) = zsshn(ji,2) * tmask(ji,2,1)
+         END DO
+      ENDIF
+
+      IF((nbondj == 1).OR.(nbondj == 2)) THEN
+         DO ji=1,jpi
+            ubdy_n(ji) = zunb(ji,nlcj-1)/(zrhoy*e2u(ji,nlcj-1)) * umask(ji,nlcj-1,1)
+            vbdy_n(ji) = zvnb(ji,nlcj-2)/(zrhox*e1v(ji,nlcj-2)) * vmask(ji,nlcj-2,1)
+            hbdy_n(ji) = zsshn(ji,nlcj-1) * tmask(ji,nlcj-1,1)
+         END DO
+      ENDIF
+
+      CALL wrk_dealloc( jpi, jpj, zunb, zvnb, zsshn )
+
    END SUBROUTINE Agrif_dta_ts
 
@@ -546,4 +818,5 @@
 
       IF( Agrif_Root() )   RETURN
+
 
       IF((nbondi == -1).OR.(nbondi == 2)) THEN
@@ -554,5 +827,5 @@
       IF((nbondi == 1).OR.(nbondi == 2)) THEN
          ssha(nlci-1,:)=ssha(nlci-2,:)
-         sshn(nlci-1,:)=sshn(nlci-2,:)
+         sshn(nlci-1,:)=sshn(nlci-2,:)        
       ENDIF
 
@@ -564,5 +837,5 @@
       IF((nbondj == 1).OR.(nbondj == 2)) THEN
          ssha(:,nlcj-1)=ssha(:,nlcj-2)
-         sshn(:,nlcj-1)=sshn(:,nlcj-2)
+         sshn(:,nlcj-1)=sshn(:,nlcj-2)                
       ENDIF
 
